//// Ejercicio 2-1 ////
////---------------////
clear;
// Definición de variables del sistema pava eléctrica //
C_1 = 400;      // Capacidad térmica Placa Metálica [J/°C]
R_1 = 0.83333;  // Resistencia térmica Interfase [°C/W]
C_2 = 4000;     // Capacidad térmica Líquido [J/°C]
R_2 = 0.3125;   // Resistencia térmica Pérdidas [°C/W]
T_a = 25;       // Temperatura ambiente [°C]

// Cálculo de las matrices del modelo de estados //
A = [-1/(C_1*R_1) 1/(C_1*R_1);
     1/(C_2*R_1) -1/C_2*(1/R_1+1/R_2)];
B = [1/C_1 0;
     0 1/(C_2*R_2)];
C = eye(2,2);
D = zeros(2,2);

// Cálculo de la respuesta temporal del sistema //
// Parte 1: //
// Cálculos auxiliares
s = poly(0,"s");            // Variable de Laplace
I_2 = eye(2,2);             // Matriz identidad de 2x2
sia = s*I_2-A;              // sI-A
adj_sia = coffg(sia);       // Adj(sI-A)
det_sia = det(sia);         // Det(sI-A)
inv_sia = adj_sia/det_sia;  // (sI-A)^-1


// Solución 
// Parte 1:
t_1 = 0:1:900;
X_0 = [25;25];                        // X(0)
U_s_1 = [500/s;25/s];                 // U(s)
X_h_s_1 = pfss(inv_sia*X_0)            // Solución homogénea en el dominio de Laplace
X_f_s_1 = pfss(inv_sia*B*U_s_1)        // Solucion forzada en el dominio de Laplace
X_t_s_1 = pfss(inv_sia*(X_0+B*U_s_1))  // Solución total en el dominio de Laplace

// Solución total en el dominio del tiempo //
X_t_t_1 = [597.9-258.3*exp(-7.074e-4*t_1)-314.6*exp(-3.393e-3*t_1);
         181.25-197.4*exp(-7.074e-4*t_1)+41.17*exp(-3.393e-3*t_1)];

// Parte 2: //
t_2 = 900:1:1800;
X_900 = X_t_t_1(:,901)                  // Valor de las variables en t = 900 s
U_s_2 = [0/s;25/s];                     // U(s)
X_h_s_2 = pfss(inv_sia*X_900)           // Solución homogénea en el dominio de Laplace
X_f_s_2 = pfss(inv_sia*B*U_s_2)         // Solución forzada en el dominio de Laplace
X_t_s_2 = pfss(inv_sia*(X_900+B*U_s_2)) // Solución total en el dominio de Laplace

// Solución total en el dominio del tiempo //
X_t_t_2 = [25+121.7*exp(-7.074e-4*(t_2-900))+299.7*exp(-3.393e-3*(t_2-900));
         25+92.98*exp(-7.074e-4*(t_2-900))-39.22*exp(-3.393e-3*(t_2-900))];

// Gráfico de las temperaturas
plot(t_1,X_t_t_1)
plot(t_2,X_t_t_2)
xlabel("Tiempo [s]]");
ylabel("Temperatura [°C]")
legend("T_c","T_h")

// Determinación del máximo
deff('y=T_h_deriv(t)', 'y = -7.074e-4*92.98*exp(-7.074e-4*(t))-3.393e-3*(-39.22)*exp(-3.393e-3*(t))');
deff('y=T_h(t)', 'y = 25+92.98*exp(-7.074e-4*(t))-39.22*exp(-3.393e-3*(t))');
t_max = fsolve(0,T_h_deriv);    // Tiempo donde ocurre el máximo luego del pulso
T_h_max = feval(t_max,T_h);     // T_h máxima         
